/*
	Devabulator by Brian Fernandes
	Version: 1.4
	Email: infernalproteus@gmail.com
	Webpage: http://thegoan.com/devabulator	
*/
var deviations = null;
var pDeviations = null;
var loadingFeed = false;
var loadingImage = false;
var chosen = null;
var adultExp = new RegExp(/\/males|\/females/i);
var category;
var subCategory;
var categoryPath;
var browseOrder;
var shadowExp = new RegExp('<span [^>]*class\\s*=\\s*"shadow"[^>]*>([^\]*?)</span>', 'gi');
var endTSExp = new RegExp('endts=([^"]*)', 'gi');
var eqAttr = '\\s*=\\s*"([^"]*)"[^>]*';
var eqExp = new RegExp(eqAttr, 'i');
var detailExp = new RegExp('<a [^>]*href'+eqAttr+' ((title'+eqAttr+')|(class'+eqAttr+'))', 'i');
var imageExp = new RegExp('<img [^>]*src'+eqAttr+' width'+eqAttr+' height'+eqAttr, 'i');
var endTS=new Date();
var offset_array = null;
var Subcategories = null;
var gifImage;
var dir = 1;

var BUTTON_VOFFSET = 46;
var MINI_BUTTON_VOFFSET = 54;

include("wallpaper.js");
include("ui.js");
include("modui.js");

initialize();

function initialize() {
	//setup the categories
	setupCategoryPreferences();	
	updatePreferences();
	changeImage(1);
}

function updatePreferences() {
	var colorize = preferences.window_color_pref.value;
	if (top_image.colorize != colorize) {
		top_image.colorize = mid_image.colorize = base_image.colorize = menuImage.colorize = midv_image.colorize = modr_image.colorize = colorize;
	}

	showBackground = preferences.background_window_pref.value;
	if (getOpacity(showBackground) != top_image.opacity) {
		base_image.opacity = mid_image.opacity = top_image.opacity = midv_image.opacity = modr_image.opacity = getOpacity(showBackground);
	}
	
	var interval = parseInt(preferences.change_pref.value);
	if (interval != change_image_timer.interval) {
		change_image_timer.ticking = false;
		change_image_timer.interval = interval;
		change_image_timer.ticking = (interval != 0) ? true : false;
	}
	

	//has the category offset changed?
	currentOffset = parseInt(preferences.offset_pref.value);
	if  (offset_array[categoryPath] != currentOffset) {
		print ("settting to " + currentOffset);
		offset_array[categoryPath] = currentOffset;
		pDeviations = null;			
	}
	print ("changed to " + preferences.offset_pref.value);
	
	/*if (browseOrder != preferences.browse_order_pref.value) {
		print ("BrowseOrder = " + browseOrder + " and pref is " + preferences.browse_order_pref.value);
		browseOrder = preferences.browse_order_pref.value;
		if (browseOrder == 9) {
			modList.check(0);
		} else if (browseOrder == 5) {
			modList.check(1);
		} else if (browseOrder == 6) {
			modList.check(2);
		} else {
			modList.setDefaultSorting();
		}
		pDeviations = null;
	}*/	

}

function getOpacity(visible) {
	return (visible != 0)? 255 : 0;
}

function getNodeValue(data, nodeName, getAll) {
	//RegExp construction by Akram Hussein
    //var rgEx = new RegExp("&lt;"+nodeName+"(?:&gt;|\ {1}[^\&gt;]*?)([^\]*?)&lt;\/"+nodeName+"&gt;", "gi");
    var regExp = new RegExp("<"+nodeName+"(?:>|\ {1}[^\>]*?)([^\]*?)<\/"+nodeName+">", "gi");
    regExp.lastIndex = 0;
	if (!getAll) {
		return regExp.exec(data)[1];
	} else {
		var results = new Array();
		var i = 0;
		do {
			result = regExp.exec(data);
			if (result) results[i++] = result;
		} while(result);
		return results;
	}
}	

function timerChangeImage() {
	if (prev_image.onMouseDown == null && dir == -1) {
		//don't go below 0
		dir = 1;
	}
	changeImage(dir);	
}

function changeImage(direction) {
	dir = direction;
	if (!pDeviations) {
		loadDeviations();
		return;
	}
	
	if (loadingImage) return;
	loadingImage = true;
		
	var freshLoad = false;
	if (chosen == null || isNaN(chosen)) {
		freshLoad = true;
		//category or sequential
		if (preferences.increment_offset_pref.value == 1) {
			resetChosen();
		} else {
			chosen = parseInt(preferences.lastImage.value);
			if (isNaN(chosen) || chosen == null) resetChosen();
		}				
	}		
	
	if (preferences.increment_offset_pref.value == 1) {
		if (!freshLoad) {
			chosen = chosen + dir;
			/*if (isNaN(offset_array[categoryPath]) || offset_array[categoryPath] == null) {
				offset_array[categoryPath] = dir * -1;
			}*/
			setCurrentOffset(offset_array[categoryPath] + dir);
		} else {
			setCurrentOffset(offset_array[categoryPath]);
		}
		if (chosen >= pDeviations.length || chosen < 0) {
			log("Resetting deviation list");
			pDeviations = null;
			loadingImage = false;
			changeImage(dir);
			return;
		}
		print(categoryPath + '=' + offset_array[categoryPath]);			
	} else {		
		if (dir == 1) {
			chosen = (chosen + dir) % pDeviations.length;
		} else {
			chosen = chosen + dir;
			if (chosen < 0) chosen = pDeviations.length + dir;			
		}
		preferences.lastImage.value = chosen;
	}
	
	loadImage();
	/*if (filterAdult()) {
		loadImage();
	} else {
		loadingImage = false;
		changeImage();
	}*/
}

function resetChosen() {
	if (dir > 0) {
		chosen = 0;
	} else {
		chosen = pDeviations.length - 1;
		var temp = parseInt(preferences.offset_pref.value);
		if (chosen > temp) {
			chosen = temp;
		}
	}
}

function setCurrentOffset(value) {
	offset_array[categoryPath] = value;
	preferences.offset_pref.value = value;
	off_text.data = value;
	if (value != 0) {
		prev_image.hslAdjustment = "";
		prev_image.onMouseDown = "changeImage(-1)";
	} else {
		prev_image.hslAdjustment = "0, -100, 0";
		prev_image.onMouseDown = null;		
	}
}

function keyPressed(key) {
	if (key == 78) {	//n
		changeImage(1);
	} else if (key == 80 && prev_image.onMouseDown != null) { //p  
		changeImage(-1);
	} else {
		print ("key pressed: " + key);
	}
}

function filterAdult() {
	if (preferences.adult_filter_pref.value == 1) {
		var category = getNodeValue(deviations[chosen], "category", false);
		if (adultExp.test(category)) return false;
	}
	return true;	
}

function loadDeviations() {
	if (loadingFeed) return;	
	loadCategoryDeviations();		
}

function loadCategoryDeviations() {
	loadingFeed = true;
	ddims.data = "Loading deviations...";
	var url = new URL();
	
	var offset = parseInt(preferences.offset_pref.value);
		 
	offset = (dir > 0) 	? offset
						: Math.max(0, offset - 24 + 1);
							
	url.location = "http://backend.deviantart.com/rss.xml"
					+ "?offset=" + offset
					+ "&dacid=muu7abqqn9lx&q=";
					
	if (categoryPath && categoryPath != "/") {
		url.location += "in:" + categoryPath;
	} else {
		url.location += "meta:all";
	}
	
	/*var order = preferences.browse_order_pref.value;
	if (order == 5) {
		//newest first
		url.location += "+sort:time+order:desc";
	} else if (order == 6) {
		//oldest first
		url.location += "+sort:time+order:asc";
	} else {
		//popular
		url.location += "+boost:popular";
	}*/
				
	url.location += modList.getModString();
			
	url.fetchAsync(categoryFeedFetched);	
	print(url.location);
}

function categoryFeedFetched(url) {
	loadingFeed = false;
	var categoryData = url.result;
	if (!categoryData || categoryData.charAt(0) == 'C') {
		ddims.data = "Error loading deviations";
	} else {
		var doc;
		try {
			doc = XMLDOM.parse(categoryData);
		} catch (e) {
			ddims.data = "Error parsing deviation feed";
			return;
		}
		var root = doc.documentElement;
		var children = root.getElementsByTagName("item");
		pDeviations = new Array();
		for (i = 0; i < children.length; i++) {
			var item = children.item(i);
			pDeviations[i] = new Object();
			pDeviations[i]['title'] = getValue(item, "title");
			pDeviations[i]['date'] = getValue(item, "pubDate");
			pDeviations[i]['link'] = getValue(item, "link");
			pDeviations[i]['wall'] = getValue(item, "media:content[@medium='image']", "url");
			pDeviations[i]['guid'] = getValue(item, "guid");
			pDeviations[i]['author'] = getValue(item, "media:credit");
			
			pDeviations[i]['dims'] = getValue(item, "media:content[@medium='image']", "width") + "x" + getValue(item, "media:content[@medium='image']", "height");
			if (pDeviations[i]['dims'] == 'nullxnull') pDeviations[i]['dims'] = "N/A";			
			
			var largethumb = getValue(item, "media:thumbnail[@width='300']", "url");
			var smallthumb = getValue(item, "media:thumbnail[not(@width='300')]", "url");			
			pDeviations[i]['largethumb'] = (largethumb != null) ? largethumb : smallthumb;
			pDeviations[i]['smallthumb'] = smallthumb;
		}
		
		if (pDeviations.length == 0) {
			//we've probably reached the end of this list of deviations
			if (preferences.offset_pref.value != 0) {							
				print("Resetting offset value");
				setCurrentOffset(0);
				pDeviations = null;
			} else {
				ddims.data = "No deviations in this category";
				return;				
			}
		}		
		chosen = null;
		changeImage(dir);
	}
}

function getValue(parent, elementName, attr) {
	var list = parent.evaluate(elementName);
	if (list && list.length >= 1) {
		if (attr) {
			var text = list.item(0);
			if (text) return text.attributes.getNamedItem(attr).value;
		} else {
			var text = list.item(0).firstChild;
			if (text) return text.data;
		}
	}
	return null;
}


function loadImage() {
	ddims.data = ddims.data + " (Loading image)";
	lDeviation = pDeviations[chosen];
	var thumbURL = new URL();
	thumbURL.location = (preferences.mini_mode_pref.value == 0) ? pDeviations[chosen]['largethumb'] : pDeviations[chosen]['smallthumb'];
	if (thumbURL.location == null || thumbURL.location.length == 0) {
		thumbURL.location = "images/missing" + ((preferences.mini_mode_pref.value == 0) ? "300" : "150") + ".png";
		thumbURL.response = 200;
		thumbnailLoaded(thumbURL, thumbURL.location);
	} else {
		thumbURL.outputFile = system.widgetDataFolder + "/tImage";
		thumbURL.fetchAsync(thumbnailLoaded);
	}
}

function thumbnailLoaded(thumbURL, alt) {
	print("starting thumbnail phase");
	loadingImage = false;
	if (alt == null && thumbURL.response == 0 || thumbURL.response >= 400) {
		ddims.data = "Error loading image"
		return;
	}
	
	var titleAuthor = lDeviation['title'] + " by " + lDeviation['author'];
	var dimInfo = "Dimensions: " + lDeviation['dims'];
	deviationLink = lDeviation['wall'];
	enableWallpaper(deviationLink != null);
	deviationID = lDeviation['guid'];
	
	//var ani = new FadeAnimation(dimage, 0, 500, animator.kEaseOut);
	//animator.runUntilDone(ani);
	if (!gifImage) {
		//fading out an aimated GIF causes Konfabulator to crash, 
		//no way to check whether GIF is animated, so stop fading all GIFs
		dimage.fade(255, 0, 5);
	}
	
	var oHeight = dimage.height;
	
	//load the image
	dimage.src = (alt == null) ? (system.widgetDataFolder + "/tImage") : alt;
	dimage.reload();
	dimage.tooltip = titleAuthor + "\n" + dimInfo + "\n" + lDeviation['date'];
	dimage.onMouseDown = "openImage('" + lDeviation['link'] + "');";
//	dimage.fade(0, 255, 2);
	dimage.opacity = 255;
	gifImage = thumbURL.location.toLowerCase().indexOf(".gif") != -1;
	if (parseFloat(konfabulatorVersion()) >= 4) {
		var dockImage = new Image();
		dockImage.src = dimage.src;		
		if ((dimage.width / dimage.height) < 1.07) { // 75/70 = 1.071
			//we should adjust according to the height
			dockImage.height = 70;
			dockImage.width = dimage.width * dockImage.height  / dimage.height;
		} else {
			dockImage.width = 75;
			dockImage.height = dimage.height * dockImage.width / dimage.width;
		}
		dockImage.saveImageToFile(system.widgetDataFolder + "/dImage.png", "png");
		var hOffset = (75-dockImage.width)/2;
		var vOffset = (70-dockImage.height)/2;
		var docItem = "<dock-item><image hOffset='" + hOffset + "' vOffset = '" + vOffset + //using hAlign and vAlign set to center seems to be buggy
			"' src = '" + system.widgetDataFolder + "/dImage.png" + "'/>" +
			"<image src = 'images/dalogo-dock.png' hOffset = '41' vOffset = '55'/>" +
			"</dock-item>";
		widget.setDockItem(docItem, "fade");
	}
	
	var miniMode = preferences.mini_mode_pref.value;
	if (miniMode == 0) {
		ddetails.data = titleAuthor;
		title_text.data = "Devabulator";
		dimage.vOffset = ddetails.vOffset + ddetails.height - 9;		
	} else {
		title_text.data = ddetails.data = "";
		dimage.vOffset = ddetails.vOffset;
	}
	
	adjustButtons(miniMode == 1);
	
	if (preferences.anchor_bottom_pref.value == 1) {
		main_window.vOffset -= (dimage.height - oHeight);
	}
	
	//adjust the background size
	var bWidth = dimage.width + 10*2;
	top_image.width = bWidth;
	mid_image.width = bWidth;	
	base_image.width = bWidth;
	
	mid_image.height = dimage.height + (dimage.vOffset - mid_image.vOffset - 12);

	base_image.vOffset = mid_image.vOffset + mid_image.height;
	
	if (miniMode == 0) {
		//resolution info		
		ddims.data = dimInfo;		
	} else {
		ddims.data = "";
	}
	ddims.vOffset = dimage.vOffset + dimage.height + 12;
	
	midv_image.height = mid_image.height + 60;
	
	modList.updateUI();
	
	print("ending thumbnail phase");
}

function adjustButtons(miniMode) {
	var vOffset;
	var diff;
	
	if (!miniMode) {
		if (next_image.vOffset != BUTTON_VOFFSET) {
			vOffset = BUTTON_VOFFSET;
			diff = 114;
		}		
	} else {
		if (next_image.vOffset != MINI_BUTTON_VOFFSET) {
			vOffset = MINI_BUTTON_VOFFSET;
			diff = -114;
		}
	}
	
	if (vOffset != null) {
		prev_image.vOffset = next_image.vOffset = category_image.vOffset = 
		wall_image.vOffset = down_image.vOffset = search_image.vOffset = vOffset;
		
		
		prev_image.hOffset += diff;
		next_image.hOffset += diff;
		category_image.hOffset += diff;		
		wall_image.hOffset +=  diff;
		down_image.hOffset += diff;
		search_image.hOffset += diff;
	}

}

function openImage(link) {
	/*if (preferences.full_view_pref.value == 1) {
		link = link.replace(/\/deviation\//, "/view/");		
	}*/
	openURL(link);
}


function setupCategoryPreferences() {
    /*var temp = preferences.category_pref.value.split(',');
    category = temp[0];
    subCategory = temp[1];*/
    categoryPath = preferences.category_path_pref.value;    
	print('category path loaded ' + categoryPath);
    //load the category offsets
    temp = preferences.offset_prefs.value.split(',');
    offset_array = new Array();
   	for (i = 0; i < temp.length; i++) {
   		var cat = temp[i].split('=');
   		if (cat.length == 2) {
   			offset_array[cat[0]] = parseInt(cat[1]);
   		}
   	}
}  

function widgetClosing() {
	var out = new Array();
	for (var i in offset_array) {
		out.push(i + "=" + offset_array[i]);
	}
	preferences.offset_prefs.value = out.join(',');
	
	preferences.mod_pref.value = modList.getMods();
		
	if (preferences.anchor_bottom_pref.value == 1) {
		//adjust height so that bottom remains anchored when Devabulator starts the next time
		main_window.vOffset -= (225 - dimage.height);
	}
	
	//increment before closing
	preferences.offset_pref.value = offset_array[categoryPath] + 1;
}