/*
	Devabulator by Brian Fernandes
	Version: 1.4
	Email: infernalproteus@gmail.com
	Webpage: http://thegoan.com/devabulator
*/
var wallChoices = new Array();
wallChoices[0] = new MenuItem();
wallChoices[0].title = "Centered";
wallChoices[0].onSelect = "setWallpaper(0)";

wallChoices[1] = new MenuItem();
wallChoices[1].title = "Tiled";
wallChoices[1].onSelect = "setWallpaper(1)";

wallChoices[2] = new MenuItem();
wallChoices[2].title = "Stretched";
wallChoices[2].onSelect = "setWallpaper(2)";

/*var mainMenu = new Array();
mainMenu[0] = new MenuItem();
mainMenu[0].title = "Download Deviation";
mainMenu[0].onSelect = "downloadDeviation()";*/

var extExp = new RegExp("\\.([^.]*)$");
var fnameExp = new RegExp("/([^/]*)$");

var wShell = null;

var dKey = "HKEY_CURRENT_USER\\Control Panel\\Desktop\\";
var deviationLink;
var prevWallDeviationLink = "";
var prevDownDeviationLink;
var downloadedDeviationLink;
var wallpaperFileName;
var oText;
var macMachine = false;
var utilPath;

//var aDesktop = COM.createObject("ActiveDesktop.IActiveDesktop");
//75048700-EF1F-11D0-9888-006097DEACF9

if (system.platform != "macintosh") {
	try {
		wShell = COM.createObject("WScript.Shell");
		utilPath = widget.extractFile("Util/topng.exe");
	} catch (e) {
		print("Could not create WScript COM object. Wallpaper support unavailable");
	}
} else {
	macMachine = true;
}

if (wShell == null && !macMachine) {
	wall_image.removeFromSuperview();
	log("Could not create WScript COM object");
}

//option for downloading wallpaper
//main_window.contextMenuItems = mainMenu;

function setAsWallpaper() {
	popupMenu(wallChoices, system.event.hOffset, system.event.vOffset);
}

function setWallpaper(mode) {
	print('set wallpaper ' + mode);
	wallpaperMode = mode;
	downloadWallpaper(true);
}

function downloadWallpaper(setWallpaper, downloadLoc) {
	if (prevWallDeviationLink != deviationLink) {
		enableWallpaper(false);
		
		oText = ddims.data;
		ddims.data = "Downloading wallpaper";
		
		print(deviationLink);
		
		var imgURL = new URL();
		imgURL.location = deviationLink;
		
		//get file name
		var name = getFName(deviationLink);
		
		//wallpaperFile = system.widgetDataFolder + "/wImage." + ext[1];
		//wallpaperFile = system.widgetDataFolder + name;
		if (downloadLoc == null) {
			loc = getDownloadLocation(true);			
			if (loc == null) {
				//cancel
				ddims.data = oText;
				enableWallpaper(true);
				return;
			}
		} else {
			//download mode - we've come here through the "Download Deviation" path
			loc = downloadLoc;
		}		
		
		loc += "/";
		
		print("download location " + loc);
				
		var parts = name.match(/(.*)\.([^\.]*)$/);
		staticName = "wImage." +  parts[2];
		
		cRequired = parts[2] != "bmp";
		
		if (preferences.save_wallpaper_pref.value == 1 || downloadLoc != null) {
			wallpaperFile = loc + name;
		} else {
			wallpaperFile = loc + staticName;
		}		

		print(wallpaperFile);
		
		imgURL.outputFile = wallpaperFile;
		if (setWallpaper) {
			imgURL.fetchAsync(wallpaperLoaded);
		} else {
			imgURL.fetchAsync(deviationDownloaded);
		}
	} else {
		if (!macMachine) updateWindowsRegistry();
	}
}

function wallpaperLoaded(imgURL) {
	print("Wallpaper downloaded");
	if (!macMachine) {
		ddims.data = "Setting wallpaper";		
		//copy the file to wImage.ext
		var wLoc = system.widgetDataFolder + "/" + staticName;
		if (preferences.save_wallpaper_pref.value == 1) {
			//if there is a file there already, delete it
			if (filesystem.itemExists(wLoc)) {
				filesystem.moveToRecycleBin(wLoc);
			}
			filesystem.copy(wallpaperFile, wLoc);
		}
				
		if (cRequired) {
			//convert to a BMP
			//var cmd = "Util/topng.exe " + "\"" + wLoc + "\" bmp";
			var cmd = "\"" + utilPath + "\" \"" + wLoc + "\" bmp";
			var b = runCommand(cmd);
			print (b);
		}
		
		updateWindowsRegistry();		
		ddims.data = oText;		
		prevWallDeviationLink = deviationLink;
	} else {
		appleScript('tell application \"Finder\" 			\
		to set desktop picture to \"' + convertPathToHFS(wallpaperFile) + '\"');
	}
	enableWallpaper(true);
}

function updateWindowsRegistry() {
	//set the wallpaper in the registry
//	wShell.RegWrite(dKey + "Wallpaper", system.widgetDataFolder + "/wImage.bmp", "REG_SZ");		
	//wShell.RegWrite(dKey + "Wallpaper", bmpFile, "REG_SZ");		
	wShell.RegWrite(dKey + "Wallpaper", system.widgetDataFolder + "/wImage.bmp", "REG_SZ");		
	//wallpaper mode
	
	var tile = (wallpaperMode == 1) ? "1" : "0";
	var stretch = (wallpaperMode == 2) ? "2" : "0";
	
	wShell.RegWrite(dKey + "TileWallpaper", tile, "REG_SZ");
	wShell.RegWrite(dKey + "WallpaperStyle", stretch, "REG_SZ");	
	
	runCommand("rundll32 user32.dll,UpdatePerUserSystemParameters");	
}

function enableWallpaper(enable) {
	if (enable) {
		wall_image.src = "Images/wallpaper.png";
		if (!macMachine) {
			wall_image.onMouseDown = "setAsWallpaper();";
		} else {
			wall_image.onMouseDown = "setWallpaper(3);";
		}
	} else {
		wall_image.src = "Images/wallpaper_bw.png";
		wall_image.onMouseDown = null;
	}
	//also enable/disable the download deviation option	
	/*mainMenu[0].enabled = enable;
	if (enable) {
		down_image.hslTinting = "0, 100, 0";
	} else {
		down_image.hslTinting = "0, 0, 0";
	}*/
}

function downloadDeviation() {
	print("Downloading deviation");
	var saveFolder = getDownloadLocation(false);	
	
	if (saveFolder) {
		var url = new URL();
		url.location = "http://www.deviantart.com/download/" + deviationID + "/";
		url.autoRedirect = false;
		url.saveFolder = saveFolder;
		url.fetchAsync(headersDownloaded);		
		
		oText2 = ddims.data;
		ddims.data += " (Downloading deviation)";		
		
		/*if (prevDownDeviationLink == deviationLink) {
			//image has been copied to wallpaper folder already, ignore			
		} else if (prevWallDeviationLink == deviationLink) {
			//image has already been used as a wallpaper, just copy it to wall paper folder
			filesystem.copy(wallpaperFile, saveFolder + "/" + wallpaperFileName);
			prevDownDeviationLink = deviationLink;
		} else {
			//download the image and save it
		}*/
	}
}

function headersDownloaded(url) {
	var location = url.getResponseHeaders("Location");	
	if (location && location.length > 0) {
		var fname = getFName(location);
		print("File name is " + fname);		
		outputFile = url.saveFolder + "/" + fname;
		
		url = new URL();
		url.location = location;
		url.outputFile = outputFile;
		print ("downloaded to " + url.outputFile);
		url.fetchAsync(deviationDownloaded);
	} else {	
		print("No download available, downloading image");
		downloadWallpaper(false, url.saveFolder);
	}
}

function getFName(url) {
	fnameExp.lastIndex = 0;
	return fnameExp.exec(url)[1];
}

function deviationDownloaded(url) {
	log("Downloaded it");
	ddims.data = oText2 + " (Downloaded)";
	enableWallpaper(true);	//just in case we downloaded the image
}
	
function getDownloadLocation(wallpaper) {
	if (wallpaper) {
		if (preferences.save_wallpaper_pref.value == 1) {
			return getDownloadLocation(false);
		} else {
			return system.widgetDataFolder;
		}
	} else {
		var location = preferences.deviation_folder_pref.value;
		if (!location || location.length == 0) {
			//ask for a folder
			return chooseFolder();
		} else {
			return location;
		}
	}
	
}