/*
	Devabulator by Brian Fernandes
	Version: 1.4
	Email: infernalproteus@gmail.com
	Webpage: http://thegoan.com/devabulator
*/
var nForeground = "#C8C8C8";
var nBackground = "#2E3735";
var hForeground = "#586608";
var hBackground = "#AFC81C";

var LEADING = "      ";
var MIN_WIDTH = 250;
var TEXT_PADDING = 20;
var MENU_HEIGHT = 350;
var MENU_SLIDE_DURATION = 150;
var MENU_FONT_SIZE = 13;
var CATDIFI = "catDiFi.js";

var gCategoryNode;
var categories;
var currentCategoryNode;
var extCatPath;
var list;
var parentFrame;
var menuFrame;
var sBar;
var count = 0;

var menuImage;
var menuBarImage;
var leftArrow;
var backItem;
var checkImage;

var menuItem = new Array();
var menuArrow = new Array();

setupCategories();
init();

function setupCategories() {
	extCatPath = system.widgetDataFolder + "/" + CATDIFI;
	var catPath;
	if (!filesystem.itemExists(extCatPath)) {
		catPath = CATDIFI;
	} else {
		catPath = extCatPath;
	}
	print("Categories loaded from: " + catPath);
	include(catPath);
}

function init() {
	setupBar();
	
	menuImage = new Image();
	menuImage.src = "Images/menusquare2.png";
//	menuImage.opacity = 192;
	menuBarImage = new Image();
	menuBarImage.src = "Images/topbar.png";
	menuBarImage.onMouseDown = "closeMenu(-1)";
	leftArrow = new Image();
	leftArrow.src = "Images/left.png";	
	leftArrow.zOrder = 100;
	checkImage = new Image();
	checkImage.src = "Images/check.png";
	checkImage.zOrder = 101;

	setupFrame();
	
	//add the popular wallpaper category
	/*var pop = new Object();
	pop.title = "Popular Wallpaper";
	pop.path = new Array();
	pop.path[0] = "art";
	pop.path[1] = POPULAR_PATH;
	gCategoryNode["children"].unshift(pop);*/
}

function setupBar() {
	sBar = new ScrollBar(main_window);
	sBar.orientation = "vertical";
	sBar.visible = false;
	sBar.autoHide = true;
}

function setupFrame() {
	parentFrame = new Frame(main_window);
	parentFrame.visible = false;
	parentFrame.hOffset = 10;
	parentFrame.vOffset = 0;
	parentFrame.opacity = 255;	
	
	menuFrame = new Frame(main_window);
	menuFrame.opacity = 255;	
	
	parentFrame.addSubview(menuFrame);	

	//setup scrolling	
	menuFrame.height = MENU_HEIGHT;
	
	//add the frame images
	parentFrame.addSubview(menuBarImage);
	parentFrame.addSubview(menuImage);
//	menuFrame.addSubview(checkImage);
	
	//backlink
	backItem = createMenuText(LEADING + "Back", 0);
	backItem.color = hBackground;
	backItem.bgColor = "#000000";
	backItem.bgOpacity = 255;
	backItem.onMouseEnter = null;
	backItem.onMouseExit = null;
	backItem.vOffset = menuBarImage.vOffset + menuBarImage.height + backItem.height - 4;
	backItem.onMouseDown = "goBack()";
	
	//left arrow
//	parentFrame.addSubview(leftArrow);
	leftArrow.hOffset = 10;
	leftArrow.vOffset = 8;
}


function clearCatFrame(frameItems) {
	clearFrameItems(frameItems);
	backItem.removeFromSuperview();
	leftArrow.removeFromSuperview();
	checkImage.removeFromSuperview();
}

function clearFrameItems(frameItems) {
	for (var i = 0; i < frameItems.length; i++) {
		frameItems[i][1].removeFromSuperview();		
		if (frameItems[i][2]) frameItems[i][2].removeFromSuperview();
	}
}

function getMenuItem(idx) {
	if (!menuItem[idx]) {
		menuItem[idx] = createMenuText("", idx);
	}
	return menuItem[idx];
}

function getMenuArrow(idx) {
	if (!menuArrow[idx]) {
		menuArrow[idx] = new Image();
		menuArrow[idx].src = "Images/right.png";
	}
	return menuArrow[idx];
}

function closeMenu(index) {
	//close the menuFrame
	if (parentFrame && parentFrame.vOffset > 0) {	
		backItem.bgOpacity = 0;
		if (index >= 0) {
			list[index][1].bgOpacity = 0;
		}
		sBar.opacity = 0;
		
		var animation = new Array();
		animation[0] = new MoveAnimation(parentFrame, 0, 0, MENU_SLIDE_DURATION, animator.kEaseOut);
		animation[1] = new FadeAnimation(parentFrame, 0,MENU_SLIDE_DURATION, animator.kEaseNone);		
		animator.runUntilDone(animation);
		return true;
	}
	return false;
}	

//side effect - will set currentCategoryNode
function findCategoryNode(path) {
	print ("Finding path " + path);
	var components = path.split('/');
	var node = findCategoryNodeA(components,  gCategoryNode);
	currentCategoryNode = node;
	if (node) {		
		if (node["children"]) return node;
		return node.backReference;
	}
	
	print('node not found');
	//odd cases
	if (path == "/") {
		currentCategoryNode = gCategoryNode;
	}
	return gCategoryNode;
}

function findCategoryNodeA(components, parentNode) {
	print("finding " + components + ", in " + parentNode.title);	
	var children = parentNode["children"];
	if (!children) return parentNode;
	var start = (parentNode.processed) ? 1 : 0;
	for (var i = start; i < children.length; i++) {
		var child = children[i];
		if (child.path[child.path.length-1] == components[0]) {
			child.backReference = parentNode;
			if (components.length > 1) {
				return findCategoryNodeA(components.slice(1), child);
			} else {
				return child;
			}
		}
	}
	/*if we're here, nothing has been found yet - try the next component if any
	this is necessary to combat a DA odditiy where sometimes an element in the path does not correspond to a category 
	(/traditional/typography/typography/calligraphy - should actually be /traditional/typography/calligraphy)*/
	if (components.length > 1) {
		return findCategoryNodeA(components.slice(1), parentNode);
	}	
}


function showCategoryMenu(parentCategory, index) {
	if (!parentCategory && closeMenu(index)) return;
	
	if (parentCategory == null && categoryPath) {
		parentCategory = findCategoryNode(categoryPath);
	}
	
	createCategoryMenu(parentCategory);	

	//slide it out if not already open
	if (parentFrame.vOffset == 0) {
		var animation = new Array();
		animation[0] = new MoveAnimation(parentFrame, 136, 70/*base_image.vOffset + base_image.height*/, MENU_SLIDE_DURATION, animator.kEaseIn);
		animation[1] = new FadeAnimation(parentFrame, 255, MENU_SLIDE_DURATION, animator.kEaseNone);
		animator.runUntilDone(animation);	
	}
	
	backItem.bgOpacity = 255;
	
	menuFrame.vScrollBar = sBar; 
	sBar.vOffset = parentFrame.vOffset + menuFrame.vOffset;	
	sBar.hOffset = parentFrame.hOffset + list[0][1].width + 5;
	
	sBar.opacity = 255;
	sBar.height = menuFrame.height;
}


function createCategoryMenu(parentCategory) {
	if (!parentCategory) {
		if (!categories) categories = gCategoryNode;
		parentCategory = categories;
	}
	
	if (list) {
		clearCatFrame(list);
	}
	
	//	menuFrame.vOffset = base_image.vOffset + base_image.height;
	//sBar.vOffset = menuFrame.vOffset;
//	menuFrame.vScrollBar = sBar;
	
	list = new Array();
	var children = parentCategory["children"];
	var pHeight = MENU_FONT_SIZE - 1;
	var mWidth = 0	
	var itemIdx = 0;
	var arrowIdx = 0;
	
	//setup this category if it hasn't been done yet
	if (!parentCategory.processed) {
		children.unshift(parentCategory);		
		parentCategory.processed = true;
	}	
	
	//do we need to add a back link?
	if (parentCategory.backReference) {
		parentFrame.addSubview(backItem);
		parentFrame.addSubview(leftArrow);
		backItem.backReference = parentCategory.backReference;
		menuFrame.vOffset = backItem.vOffset + 3;		
	} else {
		menuFrame.vOffset = menuBarImage.vOffset + menuBarImage.height - 1;
	}
	
	for (var i = 0; i < children.length; i++) {	
		list[i] = new Array();
		list[i][0] = children[i];

		//text for this entry
		var itemText;		
		if (i > 0) {
			itemText = LEADING + children[i].title;
			children[i].backReference = parentCategory;
		} else {
			var title = parentCategory.title;
			if (!title) title = "Deviations";
			itemText = LEADING + "All " + title;
		}
		
		catText = getMenuItem(itemIdx++);
		catText.width = 0;
		catText.data = itemText;
		catText.vOffset = pHeight;
		menuFrame.addSubview(catText);		
		list[i][1] = catText;
		//reset colors
		mouseExit(i);
		
		//arrow for this entry if necessary		
		if (children[i]["children"] != null && i > 0) {		
			var arrowImage;
			arrowImage = getMenuArrow(arrowIdx++);
			arrowImage.vOffset = pHeight - 9;
			menuFrame.addSubview(arrowImage);
			list[i][2] = arrowImage;
		}		
		arrowIdx++;
		
		//check for this entry		
		if (children[i] == currentCategoryNode) {
			//selected node
			checkImage.vOffset = pHeight - 9;
			checkImage.hOffset = 8;
			menuFrame.addSubview(checkImage);
		} 
		pHeight += catText.height;
		if (catText.width > mWidth) mWidth = catText.width;		
	}
	
	//width calculations
	mWidth += TEXT_PADDING;
	if (MIN_WIDTH > mWidth) mWidth = MIN_WIDTH;	
	
	for (var i = 0; i < list.length; i++) {
		list[i][1].width = mWidth-2;
		if (list[i][2]) list[i][2].hOffset = mWidth - 12;
	}	
	
	backItem.width = mWidth-2;		
	menuImage.width = mWidth;
	menuBarImage.width = mWidth;	
	
	var imgHeight = menuFrame.vOffset + pHeight - list[list.length-1][1].height;
	if (imgHeight > (menuFrame.vOffset + MENU_HEIGHT)) imgHeight = menuFrame.vOffset + MENU_HEIGHT;	
	menuImage.height = imgHeight + 3;	
	
	parentFrame.visible = true;
	return list;
}

function createArrowText(data) {
	var txt = new Text();
	txt.data = data;
	txt.size = MENU_FONT_SIZE;
//	txt.font = "Verdana";	
	return txt;
}

function createMenuText(data, i) {
	var txt = createArrowText(data);
	txt.onMouseEnter = "mouseEnter(" + i + ");";
	txt.onMouseExit = "mouseExit(" + i + ");";
	txt.onMouseDown = "switchCategory(" + i + ");";
	txt.color = nForeground;
	txt.bgColor = nBackground;
	txt.vAlign = "center";
	txt.style = "bold";
	return txt;
}


function goBack() {
	showCategoryMenu(backItem.backReference, -1);
}

function switchCategory(i) {
	var categoryNode = list[i][0];
	var children = categoryNode["children"];
	if (!children || i == 0) {
		//no more menus, this is the actual selection
		currentCategoryNode = categoryNode;
		categoryPath = categoryNode.path.slice(1).join('/');
		if (categoryPath != preferences.category_path_pref.value) pDeviations = null;
		preferences.category_path_pref.value = categoryPath;
		
		if (isNaN(offset_array[categoryPath]) || offset_array[categoryPath] == null) {
			offset_array[categoryPath] = 0;
		} else {
			//load the next devaition
			offset_array[categoryPath]++;
		}		
		preferences.offset_pref.value = offset_array[categoryPath];
		closeMenu(i);
	} else {
		if (children.length == 0) {
			loadCategory(categoryNode, i);
		} else {
			showCategoryMenu(categoryNode, i);
		}
	}
}

function loadCategory(category, index) {
	var path = category["path"].join('/');
	var url = new URL();
	url.location = 'http://www.deviantart.com/global/difi.php?c%5b%5d=Menu;get;' + path + ',2&t=jssi';
	url.categoryNode = category;
	url.index = index;
	url.fetchAsync(categoryDataFetched);	
}


function categoryDataFetched(url) {
	eval(url.result);
	print("setting cat " + DiFi.getCategoryNode());
	url.categoryNode["children"] = DiFi.getCategoryNode()["children"];
	showCategoryMenu(url.categoryNode, url.index);
}

function mouseEnter(i) {
	list[i][1].bgColor = hBackground;
	list[i][1].bgOpacity = 255;
	list[i][1].color = hForeground;
}

function mouseExit(i) {
	list[i][1].bgColor = nBackground;
	list[i][1].bgOpacity = 0;
	list[i][1].color = nForeground;
}


//CATEGORY LIST PREFETCH CODE...
var DiFi = {	
	_callbackSI: function(lookup,data) {
		categoryNode = data["DiFi"]["response"]["calls"][0]["response"]["content"];
//		document.write(data["DiFi"]["response"]["calls"][0]["response"]["content"]["children"][0].title);
	},
	
	getCategoryNode : function () {
		return categoryNode;
	}
};

function refreshCategories() {
	getAllCategories('art', null);
	var s = "var gCategoryNode = " + serializeArray(gCategoryNode);	
	filesystem.writeFile(extCatPath, s);	
	print("Category refresh complete");
}

function deleteExternalCategories() {
	filesystem.moveToTrash(extCatPath);
}

function getAllCategories(path, parentNode) {
	var url = new URL();
	url.location = 'http://www.deviantart.com/global/difi.php?c%5b%5d=Menu;get;' + path + ',2&t=json';	
	url.fetch();
	var data = eval("(" + url.result + ")");
	//var categoryNode = DiFi.getCategoryNode();
	var categoryNode = data.DiFi["response"]["calls"][0]["response"]["content"];
	print ("Finished data retrieval for " + categoryNode.title);
	if (parentNode != null) {
		parentNode["children"] = categoryNode["children"];
	} else {
		gCategoryNode = categoryNode;
	}
	processChildren(categoryNode);	
}

function processChildren(parentNode) {
	print("Processing " + parentNode.title);
	var children = parentNode["children"];
	if (!children) return;	
	for (var i = 0; i < children.length; i++) {
		var child = children[i];
		if (child["children"]) {
			if(child["children"].length > 0) {
				processChildren(child);
			} else {
				getAllCategories(child.path.join('/'), child);
			}
		}
	}
}

function serializeArray(ary) {
	//what kind of array is this?
	if (ary[0]) {
		var s2 = "\n[";
		for (var i = 0; i < ary.length; i++) {
			s2 += serializeItem(ary[i]);
			if (i != ary.length-1) s2 += ",";
		}			
		s2 += "]";
		return s2;
	} else {
		//associative array
		var tArray = new Array();
		var j = 0;
		for (var i in ary) {
			var s2 = '"' + i + '":';
			s2 += serializeItem(ary[i]);
			tArray[j++] = s2;
		}	
		return "\n{" + tArray.join(',') + "}";
	}
	return "";
}

function serializeItem(item) {
	var s2;
	if (item instanceof Array || item instanceof Object) {
		s2 = serializeArray(item);
	} else {
		if (item) {
			s2 = '"' + item + '"';
		} else {
			s2 = "null";
		}
	}
	return s2;
}
